@echo off
rem    vss-exec.cmd
rem  
set wd=C:\bkp\
rem      
set vsh=vshadow64.exe
rem   ,    
set bkpf=\\server\backup\servername

rem       
set file1=C_01_c.wim
set file2=C_02_c.wim

rem     
set maxindex=7

rem        
set drive=C:
set bkpfiels=B:\

rem     
set error=0
set parity=0

rem   
set smtpserver=smpt.server
set sender=user@mail.ru
set recipient=user@mail.ru


del /q %wd%\*.log
del /q %wd%\*.txt

if exist "%wd%\parity" set parity=1

call "%wd%\setvar1.cmd"
"%wd%\%vsh%" -ds=%shadow_id_1%
"%wd%\dosdev.exe" /D B:

echo Log date: %date%	time: %time% > "%wd%\error.log"
echo Log date: %date%	time: %time% > "%wd%\log.log"

echo ------------------------------------ > %wd%\log.log
echo   Windows  %computername%   >> %wd%\log.log
echo ------------------------------------ >> %wd%\log.log

rem  
echo Start backup: 	%time%  > %wd%\Time_log.log
echo. >> %wd%\Time_log.log

rem  
cls
echo 	--- Create VSS copy --- >"%wd%\vss.log"

"%wd%\%vsh%" -p -nw -script="%wd%\setvar1.cmd" %drive% >> "%wd%\vss.log"
echo create shadow %errorlevel% >> "%wd%\error.log"
set /a error=%errorlevel%+%error%

echo 	--- Call Set Var script --- >>"%wd%\vss.log"

call "%wd%\setvar1.cmd" >> "%wd%\vss.log"
echo call setvar.cmd %errorlevel% >> "%wd%\error.log"
set /a error=%errorlevel%+%error%

echo 	--- Mount VSS as drive B --- >>"%wd%\vss.log"

"%wd%\%vsh%" -el=%shadow_id_1%,B: >> "%wd%\vss.log"
echo Mount SnapShot %errorlevel% >> "%wd%\error.log"
set /a error=%errorlevel%+%error%

if %parity% == 1 (set file=%file1%
)

if %parity% == 0 (set file=%file2%
)

rem    
set ind=0

"%wd%\imagex.exe" /info "%bkpf%\%file%" | find /I "Image Count" > "%wd%\index.txt"
FOR /f "tokens=1,2,3" %%a IN (%wd%\index.txt) do set ind=%%c

if %ind% GEQ %maxindex% (
"%wd%\imagex.exe" /delete "%bkpf%\%file%" 1 >> "%wd%\del.log"
echo ImageX Index Delete %errorlevel% >> "%wd%\error.log"
set /a error=%errorlevel%+%error%
)

"%wd%\imagex.exe" /append %bkpfiels% "%bkpf%\%file%" "%Drive% drive %date% %time%" "%date% %time%" /verify /config "%wd%\conf.ini" /flags "ServerEnterprise" >> "%wd%\imagex.log"

rem   ,     (3 )
if not %errorlevel% == 0 (
echo error = %errorlevel%
echo 1 >> %wd%\stop.txt
ping 127.0.0.1 -n 4
echo RESTART >> %wd%\restart.err
type "%wd%\imagex.log" >> %wd%\log.err
start %wd%\restart.bat
exit
)

set ok=0

for /f "tokens=1,2" %%i in ('type %wd%\imagex.log') do (
if "%%i %%j" == "Successfully imaged" set ok=1
)

if not %ok% == 1 (
echo ok = %ok%
echo 1 >> %wd%\stop.txt
ping 127.0.0.1 -n 4
echo RESTART >> %wd%\restart.err
start %wd%\restart.bat
exit
)

echo ImageX %errorlevel% >> "%wd%\error.log"
set /a error=%errorlevel%+%error%

"%wd%\imagex.exe" /info "%bkpf%\%file%" | find /I "Description" >> "%wd%\descr.log"

echo 	--- Del Mount VSS copy drive B --- >>"%wd%\vss.log"

"%wd%\dosdev.exe" /D B: >> "%wd%\vss.log"
echo Unmount Drive %errorlevel% >> "%wd%\error.log"
set /a error=%errorlevel%+%error%

echo 	--- Del current VSS copy --- >>"%wd%\vss.log"

"%wd%\%vsh%" -ds=%shadow_id_1% >> "%wd%\vss.log"
echo Delete SnapShot %errorlevel% >> "%wd%\error.log"
set /a error=%errorlevel%+%error%

rem  
echo Stop backup: 	%time%  >> %wd%\Time_log.log

echo. >> "%wd%\error.log"
echo Errors %error% >> "%wd%\error.log"

rem      
if %parity% == 1 del /q "%wd%\parity"
if %parity% == 0 echo parity > "%wd%\parity"

if exist %wd%\restart.err (
echo. >> %wd%\log.log
echo -=-=-=-=-=-=-=-=-=-=-=-=- >> %wd%\log.log
type %wd%\restart.err >> %wd%\log.log
echo -=-=-=-=-=-=-=-=-=-=-=-=- >> %wd%\log.log
echo. >> %wd%\log.log
)

echo. >> %wd%\log.log
echo. >> %wd%\log.log
type "%wd%\time_log.log" >> %wd%\log.log
echo. >> %wd%\log.log
type "%wd%\imagex.log" | find /I "Total elapsed time" >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo -===============  WIM content  ===================- >> %wd%\log.log
echo. >> %wd%\log.log
type "%wd%\descr.log" >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo -===============  Error Log  ===================- >> %wd%\log.log
echo. >> %wd%\log.log
type %wd%\error.log >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo -================  ImageX Log  ==================- >> %wd%\log.log
type %wd%\imagex.log >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo -================  VSS Log  ==================- >> %wd%\log.log
echo. >> %wd%\log.log
type %wd%\vss.log >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo -================  Log err  ==================- >> %wd%\log.log
echo. >> %wd%\log.log
type %wd%\log.err >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo. >> %wd%\log.log
echo End of Log>> %wd%\log.log

del /q %wd%\restart.err
del /q %wd%\log.err

rem     
%wd%\bmail.exe -s %smtpserver% -t %sender% -f %recipient% -h Header -a "Windows Server on %computername% [%error%] %date%" -m %wd%\log.log

rem    
for /f "tokens=1,2,3* delims=:," %%a in ('time /t') do set now=%%a.%%b
copy "%wd%\log.log" "%bkpf%\%date%_%now%.log"
exit
